<template>
  <div v-if="fileData" class="base-price-view-import-file">

    <BasePriceLoader v-if="isShowLoader" />

    <div class="import-file-title">{{ fileData.title }}</div>

    <div class="row">
      <div class="col-md-8">

        <table class="import-file-info">
          <tr>
            <td class="import-file-info__title">
              Автор загрузки:
            </td>
            <td class="import-file-info__value">
              {{ fileData.userInfo }}
            </td>
          </tr>
          <tr>
            <td class="import-file-info__title">
              Загружено:
            </td>
            <td class="import-file-info__value">
              {{ fileData.date_download | date('DD.MM.YYYY, HH:mm') }}
            </td>
          </tr>
          <tr>
            <td class="import-file-info__title">
              Активировано:
            </td>
            <td class="import-file-info__value">
              <div v-if="fileData.activated_at">
                {{ fileData.activated_at | date('DD.MM.YYYY, HH:mm') }}
              </div>
            </td>
          </tr>
          <tr v-if="fileData.koef">
            <td class="import-file-info__title">
              Коэф-т доверия:
            </td>
            <td class="import-file-info__value">
              {{ fileData.koef }}
            </td>
          </tr>
          <tr v-if="fileData.curStatus">
            <td class="import-file-info__title">
              Статус:
            </td>
            <td class="import-file-info__value">
              {{ fileStatus[fileData.curStatus] }}
            </td>
          </tr>
        </table>

      </div>
      <div class="col-md-4">

        <table class="import-file-info to-right">
          <tr>
            <td class="import-file-info__title">
              Строк всего:
            </td>
            <td class="import-file-info__value">
              {{ fileData.strings_count }}
            </td>
          </tr>
          <tr>
            <td class="import-file-info__title">
              Загружено успешно:
            </td>
            <td class="import-file-info__value">
              {{ fileData.strings_count_good }}
            </td>
          </tr>
          <tr :class="{ link: fileData.processed_file_uuid }" @click="$emit('download', fileData.processed_file_uuid )">
            <td class="import-file-info__title">
              <i class="icon download"></i>
              Отброшено:
            </td>
            <td class="import-file-info__value">
              {{ fileData.strings_count_bad }}
            </td>
          </tr>
        </table>

      </div>
    </div>

    <div class="upload-file-container">
      <div class="import-file-title__big">Файл экспертных значений</div>
      <ob-uploader
          :multiple="false"
          ref="uploader"
          :is-read-only="true"
          :value="uploadedFileData"
      />
    </div>

    <ObAlert
      v-if="!isActivated"
      theme-icon="info"
      icon="question"
      :hide-close-button="true"
    >
      После нажатия на кнопку «Активировать» файл активируется в ближайшее возможное время, согласно расписанию.
    </ObAlert>

    <div class="button-container">
      <ObButton
        v-if="fileData.curStatus === 'LOADED'"
        label="Активировать"
        type="primary"
        @click="activate"
        data-qa="buttonActivatedBP"
      />
      <ObButton
        v-if="fileData.curStatus === 'ACTIVATED'"
        label="Деактивировать"
        type="primary"
        :danger="true"
        @click="deActivate"
        data-qa="buttonDeactivatedBP"
      />
      <ObButton
        label="Закрыть"
        :type="!isActivated ? 'flat' : 'primary'"
        @click="close"
        data-qa="buttonCloseBP"
      />
    </div>

  </div>
</template>

<script>
import api from '@/api';
import obUploader from 'common-components/src/obComponents/obUploader';
import ObAlert from 'common-components/src/obComponents/obAlert';
import ObButton from 'common-components/src/obComponents/obButton';
import BasePriceLoader from './loader';
import { fileStatus } from "@/constants/basePrice.js";

export default {
  name: "BasePriceImportViewFile",
  components: {
    obUploader,
    ObAlert,
    ObButton,
    BasePriceLoader,
  },
  props: {
    fileData: {
      type: Object,
      default: () => {},
      required: true,
    },
  },
  data () {
    return {
      fileStatus,
      isShowLoader: false,
    }
  },
  computed: {
    uploadedFileData() {
      return {
        uuid: this.fileData.file_uuid,
        file: {
          name: this.fileData.file_name,
        },
        isUploaded: true
      }
    },
    isActivated() {
      return this.fileData.activated_at;
    },
  },
  methods: {
    close() {
      this.$emit('close')
    },
    async activate() {
      let uuid = this.fileData.uuid;
      if (uuid) {
        try {
          this.isShowLoader = true;
          await api.base_prices_data_import.activation(uuid)
            .then((res) => {
              if (res.error && res.status === 404) {
                this.$notification({
                  type: "system_notification_error",
                  message: "Загруженные файлы такого типа не найдены",
                });
              } else {
                this.$notification({
                  type: "system_notification_success",
                  message: "Активация файла прошла успешно",
                });
                this.$emit("activate", { });
              }
            })
            .finally(() => {
                this.isShowLoader = false;
            });
        } catch (e) {
          console.error("activation error ->", e);
          this.isShowLoader = false;
          this.$notification({type: 'system_notification_error', message: 'Ошибка активации'})
        }
      } else {
        this.$notification({type: 'system_notification_error', message: 'Ошибка активации'})
      }
    },
    async deActivate() {
      let uuid = this.fileData.uuid;
      if (uuid) {
        try {
          this.isShowLoader = true;
          await api.base_prices_data_import.deActivation(uuid)
            .then((res) => {
              if (res.error) {
                this.$notification({
                  type: "system_notification_error",
                  message: "Ошибка деактиваци файла",
                });
              } else {
                this.$notification({
                  type: "system_notification_success",
                  message: "Деактивация файла прошла успешно",
                });
                this.$emit("activate", { });
              }
            })
            .finally(() => {
                this.isShowLoader = false;
            });
        } catch (e) {
          console.error("activation error ->", e);
          this.isShowLoader = false;
          this.$notification({type: 'system_notification_error', message: 'В процессе обработки запроса произошла ошибка'})
        }
      } else {
        this.$notification({type: 'system_notification_error', message: 'Ошибка деактивации, не передан uuid файла'})
      }
    }
  }
};
</script>

<style lang="scss">
  @import "~common-components/src/static/css/mixins";
  .base-price-view-import-file{
    position: relative;

    .link{
      color: $blue-dust;
      cursor: pointer;

      i{
        margin-right: 5px;
      }

      td:first-child{
        display: flex;
        justify-content: flex-end;
        align-items: center;
      }
    }

    .import-file-title{
      font-size: 16px;
      font-weight: 400;
      color: $cobalt-black;
      margin-bottom: 30px;
      &__big{
        font-size: 20px;
        font-weight: 700;
        margin-bottom: 15px;
        color: $cobalt-black;
      }
    }

    .import-file-info{
      color: $cobalt-black;
      margin-bottom: 30px;

      &.to-right{
        margin-left: auto;
      }

      td{
        padding: 5px;
      }

      &__title{
        text-align: right;
        min-width: 120px;
      }
      &__value{

      }
    }

    .upload-file-container{
      margin-bottom: 30px;
    }

    .ob-alert-container{
      margin-bottom: 40px;
    }

    .button-container{
      display: flex;
      .ob-button-container{
        margin-right: 20px;
      }
    }
  }
</style>